# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- test
- build
- copy_files_to_server
- run

## TEMPLATES:
.ssh-config: &ssh
- which ssh-agent
- eval $(ssh-agent -s)
- echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
- mkdir -p ~/.ssh
- chmod 700 ~/.ssh

sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml

variables:
  DEST: "docker.gitlab.gwdg.de/subugoe/ocr-d/quiver-benchmarks"
  IMAGE_NAME: "${DEST}:${CI_COMMIT_BRANCH}-${CI_COMMIT_SHORT_SHA}"

.build_image:
  stage: build
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint:
    - ''
  except:
    - triggers
  script:
  - echo "Pushing image to ${DEST}"
  - mkdir -p /kaniko/.docker
  - echo "{\"auths\":{\"${CI_REGISTRY}\":{\"auth\":\"$(printf "%s:%s" "${CI_REGISTRY_USER}" "${CI_REGISTRY_PASSWORD}" | base64 | tr -d '\n')\"}}}" > /kaniko/.docker/config.json
  - /kaniko/executor 
    --context "${CI_PROJECT_DIR}" 
    --dockerfile "${CI_PROJECT_DIR}/Dockerfile"
    --build-arg build_date=$(date -u +'%Y-%m-%dT%H:%M:%SZ')
    --destination ${IMAGE_NAME}

copy_files_to_server:
  stage: copy_files_to_server
  image: docker.gitlab.gwdg.de/mrodzis/docker-images/debian
  except:
    - triggers
  script:
  - *ssh
  - scp -o 'StrictHostKeyChecking no' -r Dockerfile $SSH_USER@$SSH_IP:~/ocr-application/Dockerfile
  - scp -o 'StrictHostKeyChecking no' -r data_srcs $SSH_USER@$SSH_IP:~/ocr-application
  - scp -o 'StrictHostKeyChecking no' -r docker-compose.yaml $SSH_USER@$SSH_IP:~/ocr-application/docker-compose.yaml
  - scp -o 'StrictHostKeyChecking no' -r requirements.txt $SSH_USER@$SSH_IP:~/ocr-application/requirements.txt
  - scp -o 'StrictHostKeyChecking no' -r scripts $SSH_USER@$SSH_IP:~/ocr-application
  - scp -o 'StrictHostKeyChecking no' -r setup.py $SSH_USER@$SSH_IP:~/ocr-application/setup.py
  - scp -o 'StrictHostKeyChecking no' -r src $SSH_USER@$SSH_IP:~/ocr-application
  - scp -o 'StrictHostKeyChecking no' -r workflows $SSH_USER@$SSH_IP:~/ocr-application
  - scp -o 'StrictHostKeyChecking no' -r README.md $SSH_USER@$SSH_IP:~/ocr-application/README.md

rebuild_and_run:
  stage: run
  image: docker.gitlab.gwdg.de/mrodzis/docker-images/debian
  only:
    - triggers
  script:
  - *ssh
  # the $RELEASE_TAG variable is transmitted to the pipeline via payload by the webhook application
  - echo "RELEASE_TAG=$RELEASE_TAG" > .env
  - scp -o 'StrictHostKeyChecking no' -r .env $SSH_USER@$SSH_IP:~/ocr-application/.env
  - ssh -o 'StrictHostKeyChecking no' $SSH_USER@$SSH_IP "docker pull ocrd/all:maximum"
  - ssh -o 'StrictHostKeyChecking no' $SSH_USER@$SSH_IP "docker compose -f ~/ocr-application/docker-compose.yaml build --no-cache"
  - ssh -o 'StrictHostKeyChecking no' $SSH_USER@$SSH_IP "docker compose -f ~/ocr-application/docker-compose.yaml up -d"
